#include "main.h"

static void handle_key_down( SDL_keysym* keysym ) /* Werden Tasten gedrckt? */
{
	switch( keysym->sym )
	{
		case SDLK_ESCAPE:
			if (intro_running) skip_intro(); else scene_ende = !scene_ende;
			break;
		case SDLK_KP_ENTER:
			if (intro_running) skip_intro(); else key_return = 1;
			break;
		case SDLK_RETURN:
			if (intro_running) skip_intro(); else key_return = 1;
			break;
		case SDLK_UP:
			key_up = 1;
			break;
		case SDLK_DOWN:
			key_down = 1;
			break;
		case SDLK_RIGHT:
			key_right = 1;
			break;
		case SDLK_LEFT:
			key_left = 1;
		default:
			break;
	}
}

static void handle_key_up( SDL_keysym* keysym ) /* Werden Tasten wieder losgelassen? */
{
	switch( keysym->sym )
	{
		case SDLK_UP:
			key_up = 0;
			break;
		case SDLK_DOWN:
			key_down = 0;
			break;
		case SDLK_RIGHT:
			key_right = 0;
			break;
		case SDLK_LEFT:
			key_left = 0;
			break;
		case SDLK_KP_ENTER:
			key_return = 0;
			break;
		case SDLK_RETURN:
			key_return = 0;
			break;
		default:
			break;
	}
}

void process_events( void )
{
	SDL_Event event; /* Speichert die Events */

	while( SDL_PollEvent( &event ) ) /* Alle Events abholen, die verarbeitet werden mssen */
	{

		switch( event.type )
		{
			case SDL_KEYDOWN: /* Es wurde eine Taste gedrckt, jetzt zur Funktion springen, die das verarbeitet */
				handle_key_down( &event.key.keysym );
				break;
			case SDL_KEYUP: /* Es wurde eine Taste losgelassen, jetzt zur Funktion springen, die das verarbeitet */
				handle_key_up( &event.key.keysym );
				break;
			case SDL_QUIT: /* Das Programm wird beendet (egal wie, ob gewollt oder durch Abbruch */
				quit( 0 );
				break;
		}
	}
}
