#ifndef _main_H
#define _main_H

#include <SDL.h>
/*#include <SDL_opengl.h>*/
#include <GL/gl.h>
#include <GL/glu.h>

#include <SDL_image.h>
#include <SDL_mixer.h>

#include <config.h>

#include <stdlib.h>
#include <string.h>

/*<- SETTINGS */


/*-comfort_begin-
	the next few lines are for making anjuta a bit more comfortable.
	maybe theres a better way of managing data dirs, but i haven't found
	a good method in the docs -> tell me
*/

#ifndef _WIN32
	/*#define DEBUG*/
	
	#ifdef DEBUG
	#define PIXMAP_DIR	PACKAGE_SOURCE_DIR"/pixmaps"	/*DEBUG*/
	#define DATA_DIR 	PACKAGE_SOURCE_DIR"/data"		/*DEBUG*/
	#else
	#define PIXMAP_DIR	PACKAGE_PIXMAPS_DIR				/*RELEASE*/
	#define DATA_DIR	PACKAGE_DATA_DIR				/*RELEASE*/
	#endif
#else
	/* win32 users want their apps to be in one directory only */
	#define PIXMAP_DIR	"./pixmaps"
	#define DATA_DIR	"./data"
#endif

/*-comfort_end-*/

/* textures */
	#define NUM_TEXTURES 8 /* Die Anzahl der zu ladenden Texturen */
		#define TEXTURE_PATH_font PIXMAP_DIR"/font.png"
		#define TEXTURE_font 0

		#define TEXTURE_PATH_g PIXMAP_DIR"/g.png"
		#define TEXTURE_g 1

		#define TEXTURE_PATH_g_top PIXMAP_DIR"/g_top.png"
		#define TEXTURE_g_top 2

		#define TEXTURE_PATH_b PIXMAP_DIR"/b.png"
		#define TEXTURE_b 3

		#define TEXTURE_PATH_skybox PIXMAP_DIR"/skybox.png"
		#define TEXTURE_skybox 4

		#define TEXTURE_PATH_acid PIXMAP_DIR"/acid.png"
		#define TEXTURE_acid 5

		#define TEXTURE_PATH_acidfog PIXMAP_DIR"/acidfog.png"
		#define TEXTURE_acidfog 6
		
		#define TEXTURE_PATH_menu PIXMAP_DIR"/menu.png"
		#define TEXTURE_menu 7
	GLuint texture[NUM_TEXTURES]; /* Textur-Array: Speichert alle Texturen */

/* Sounds */
		#define NUM_SOUNDS 6 /* number of sounds to load */
		#define SOUND_PATH_walk DATA_DIR"/walk.ogg"
		#define SOUND_walk 0
		#define SOUND_PATH_wind DATA_DIR"/wind.ogg"
		#define SOUND_wind 1
		#define SOUND_PATH_menuchange DATA_DIR"/menu_change.ogg"
		#define SOUND_menuchange 2
		#define SOUND_PATH_atom DATA_DIR"/atom.ogg"
		#define SOUND_atom 3
		#define SOUND_PATH_explode DATA_DIR"/explode.ogg"
		#define SOUND_explode 4
		#define SOUND_PATH_jump DATA_DIR"/jump.ogg"
		#define SOUND_jump 5
	GLint sound_channels[NUM_SOUNDS]; /* stores which channel sdl_mixer uses for a specific sound */
	Mix_Chunk *sound[NUM_SOUNDS]; /* sound-array: stores all sounds */
	Mix_Music *music;
		#define MUSIC_PATH_ingame DATA_DIR"/ingame_music.ogg"
	
/* animationsgeschwindigkeiten */
	GLfloat FrameInterval; /* Enthlt die Zeit, die fr den letzten Frame gebraucht wurde (Wichtig fr Animationen!) */
	GLint fps; /* Speichert die FPS */
		#define cam_move 20.0f
		#define logo_spin 50.0f
		#define acid_move 2.5f
/* Displaylists */
	#define NUM_DLISTS 9 /* Die Anzahl der zu erstellenden Displaylists fr Objekte*/
		GLuint DLIST_skybox;
		GLuint DLIST_ground;
		GLuint DLIST_block;
		GLuint DLIST_acid;
		GLuint DLIST_foot;
		GLuint DLIST_glasses;
		GLuint DLIST_body;
		GLuint DLIST_atom;
		GLuint DLIST_acidfog;
	GLuint dlist[NUM_DLISTS]; /* Displaylist-Array: Speichert alle Objekte */
		
/* levelsize */
	#define LEVEL_SIZE_x 520
	#define LEVEL_SIZE_y 8

/* SETTINGS -> */

GLuint loop, loop2;	/* allgemeine Loopvariablen */

void quit(GLint code);

GLboolean scene_ende; /* Zum verlassen der Loopschleifen */

/* Speichert die Zustnde der Tasten */
GLboolean key_up;
GLboolean key_down;
GLboolean key_right;
GLboolean key_left;
GLboolean key_return;

/* Kameraposition: */
GLfloat camx;
GLfloat camz;

GLboolean intro_running; /* needed for the intro, should be put into scenes.c, when the ESCAPE event is rewritten */

GLboolean levelrun; /* Speichert ob gerade ein Spiel luft, wichtig fr das Hauptmen */

GLbyte lvl[LEVEL_SIZE_x][LEVEL_SIZE_y]; /* Level-Array, speichert den Levelaufbau */
GLboolean level_created; /* needed for the "Replay level" option */
GLuint font;	/* Speichert die Displaylists fr die Schrift */
char pre_string[63]; /* Um Integers als String auszugeben (temporre Zwischenspeicherung) */

#endif
